import java.util.*;

/**
 * Represents a grid on which green and red frogs interact,
 * and runs the simulation.
 * 
 * @author COMP 1711 instructors
 * @version 2005-11-05
 */
public class Simulator
{
    private static final Random simRand = new Random();
    private static final int DEFAULT_NUM_GREEN = 20;
    private static final int DEFAULT_NUM_RED = 5; 
    private static final int NUM_DIRECTIONS = 4;

    // Constants for directions green frogs can move
    public static final int NORTH = 0;
    public static final int EAST = 1;
    public static final int SOUTH = 2;
    public static final int WEST = 3;

    // Constants for directions red frogs can move
    public static final int NORTH_WEST = 0;
    public static final int NORTH_EAST = 1;
    public static final int SOUTH_EAST = 2;
    public static final int SOUTH_WEST = 3;

    // Constants for the grid
    public static final int GRID_SIZE = 10;    // number of rows/colums in grid
    public static final int GRID_SQUARE_WIDTH = (Frog.CANVASMAXRIGHT + 1)/GRID_SIZE;
    public static final int GRID_SQUARE_HEIGHT = (Frog.CANVASMAXDOWN + 1)/GRID_SIZE;           

    // Constants specifically for drawing the "pips" at corners of grid squares
    private static final int PIP_SIDE = 4;
    private static final String PIP_COLOR = "black";
    private static final int INIT_SQUARE_X = 60;    
    private static final int INIT_SQUARE_Y = 50;
    
    // Non-constant fields
    private Square[][] Pips;

    //---------------------------------------------------------------------------

    /**
     * Draws the squares representing the "pips" at the corners of grid positions.
     */
    private void drawPips()
    {
        Pips = new Square[GRID_SIZE + 1][GRID_SIZE + 1];
        for (int i = 0; i <= GRID_SIZE; i++)
        {
            for (int j = 0; j <= GRID_SIZE; j++)
            {
                Pips[i][j] = new Square();
                Pips[i][j].changeColor(PIP_COLOR);
                Pips[i][j].changeSize(PIP_SIDE);
                Pips[i][j].moveHorizontal(j*GRID_SQUARE_WIDTH - INIT_SQUARE_X - PIP_SIDE/2);
                Pips[i][j].moveVertical(i*GRID_SQUARE_HEIGHT - INIT_SQUARE_Y - PIP_SIDE/2);
                Pips[i][j].makeVisible();
            }// for j
        } // for i
    } // drawPips
    
    //---------------------------------------------------------------------------

} // class Simulator
